<template>
  <nav
    ref="navbar"
    class="h-20 w-full bg-gray-100 lg:flex"
    role="navigation"
    aria-label="main navigation"
  >
    <div class="flex items-center justify-between h-full px-2">
      <navbar-brand-logo class="px-2" v-bind="logo" />
      <navbar-burger
        class="hamburger--squeeze px-2 z-50 lg:hidden"
        :active="isOpen"
        @click="isOpen = !isOpen"
      />
    </div>

    <transition
      enter-active-class="fx-circle-in-tr animation-ease-in-out animation-fast"
      leave-active-class="fx-circle-in-tr animation-ease-in-out animation-slowest animation-reverse"
    >
      <navbar-menu-mobile v-if="isOpen" :items="navbarItems" @item-tapped="isOpen = false" />
    </transition>

    <navbar-menu-desktop class="hidden lg:block" :items="navbarItems" />
  </nav>
</template>

<script>
import {
  disableBodyScroll,
  enableBodyScroll,
  clearAllBodyScrollLocks,
} from 'body-scroll-lock';

import NavbarBrandLogo from './NavbarBrandLogo';
import NavbarBurger from './NavbarBurger';
import NavbarMenuMobile from './NavbarMenuMobile';
import NavbarMenuDesktop from './NavbarMenuDesktop';

export default {
  name: 'Navbar',
  components: {
    NavbarBrandLogo,
    NavbarBurger,
    NavbarMenuMobile,
    NavbarMenuDesktop,
  },
  inject: ['site'],
  data() {
    return {
      isOpen: false,
    };
  },
  computed: {
    routes() {
      return this.site.routes;
    },
    navbarItems() {
      const { navbar_items } = this.site.navigation;
      return navbar_items.map(this.navItem);
    },
    logo() {
      const { image, description } = this.site.logos.primary;

      return {
        image: require(`!!assets-loader!../../../static${image}`),
        description,
      };
    },
  },
  watch: {
    isOpen: function(val, oldVal) {
      val
        ? disableBodyScroll(this.$refs.navbar)
        : enableBodyScroll(this.$refs.navbar);
    },
  },
  beforeDestroy() {
    clearAllBodyScrollLocks();
  },
  methods: {
    navItem(item) {
      return {
        id: item.id,
        label: item.label,
        path: this.routes[item.id],
        children: item.children ? item.children.map(this.navItem) : [],
      };
    },
  },
};
</script>
